/***********************************************************************
*
* Copyright (c) 2021-2022 Barbara Geller and Ansel Sermersheim
*
* This example is free software, released under the BSD 2-Clause license.
* For license details refer to LICENSE provided with this project.
*
* CopperSpice is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
*
* https://opensource.org/licenses/BSD-2-Clause
*
***********************************************************************/

#include <QtCore>
#include <QtGui>

class MainWindow : public QWidget
{
 public:
   MainWindow();
};

MainWindow::MainWindow()
{
   setMinimumSize(600, 350);

   //
   QLabel *label_1 = new QLabel("Name:");

   QLineEdit *text_1 = new QLineEdit();
   text_1->setPlaceholderText("Enter your full name...");

   //
   QLabel *label_2 = new QLabel("Activities/Hobbies:");
   label_2->setAlignment(Qt::AlignLeft|Qt::AlignTop);

   QCheckBox *cb_1 = new QCheckBox{"Cooking"};
   QCheckBox *cb_2 = new QCheckBox{"Gardening"};
   QCheckBox *cb_3 = new QCheckBox{"Hiking"};
   QCheckBox *cb_4 = new QCheckBox{"Photography"};
   QCheckBox *cb_5 = new QCheckBox{"Reading"};
   QCheckBox *cb_6 = new QCheckBox{"Swimming"};
   QCheckBox *cb_7 = new QCheckBox{"Traveling"};
   QCheckBox *cb_8 = new QCheckBox{"Wood Working"};

   //
   QLabel *label_3 = new QLabel("Favorite City:");

   QComboBox *comboBox_3 = new QComboBox();
   comboBox_3->setMinimumSize(150, 0);
   comboBox_3->setSizePolicy(QSizePolicy::Fixed, QSizePolicy::Fixed);

   comboBox_3->addItems( {"London", "Paris", "Munich", "Berlin", "Stuttgart", "Brussels",
      "Amsterdam", "Copenhagen", "Zürich", "Barcelona", "San Francisco", "New Orleans",
      "New York", "Chicago", "Boston", "Sydney", "Tokyo"} );

   comboBox_3->model()->sort(0);
   comboBox_3->setCurrentIndex(0);

   //
   QLabel *label_4 = new QLabel("Biography:");

   QPlainTextEdit *text_4 = new QPlainTextEdit();
   text_4->setPlaceholderText("Multiple lines of text...");
   text_4->setMaximumHeight(100);
   text_4->setTabChangesFocus(true);

   QPushButton *pb_1 = new QPushButton();
   pb_1->setText("Close");

   QGridLayout *layout_cb = new QGridLayout();
   layout_cb->setVerticalSpacing(5);
   layout_cb->addWidget(cb_1, 0, 0);
   layout_cb->addWidget(cb_2, 1, 0);
   layout_cb->addWidget(cb_3, 2, 0);
   layout_cb->addWidget(cb_4, 3, 0);

   layout_cb->addWidget(cb_5, 0, 1);
   layout_cb->addWidget(cb_6, 1, 1);
   layout_cb->addWidget(cb_7, 2, 1);
   layout_cb->addWidget(cb_8, 3, 1);

   QFormLayout *layout1 = new QFormLayout();
   layout1->setVerticalSpacing(20);
   layout1->addRow(label_1, text_1);
   layout1->addRow(label_2, layout_cb);
   layout1->addRow(label_3, comboBox_3);
   layout1->addRow(label_4, text_4);

   QHBoxLayout *layout2 = new QHBoxLayout();
   layout2->addStretch();
   layout2->addWidget(pb_1);
   layout2->addStretch();

   QVBoxLayout *layoutMain = new QVBoxLayout(this);
   layoutMain->setContentsMargins(45, 35, 45, 15);

   layoutMain->addLayout(layout1);
   layoutMain->addSpacing(20);
   layoutMain->addLayout(layout2);

   QWidget::setTabOrder(text_1, cb_1);
   QWidget::setTabOrder(cb_1,   cb_5);
   QWidget::setTabOrder(cb_5,   cb_2);
   QWidget::setTabOrder(cb_2,   cb_6);
   QWidget::setTabOrder(cb_6,   cb_3);
   QWidget::setTabOrder(cb_3,   cb_7);
   QWidget::setTabOrder(cb_7,   cb_4);
   QWidget::setTabOrder(cb_4,   cb_8);
   QWidget::setTabOrder(cb_8,   comboBox_3);
   QWidget::setTabOrder(comboBox_3, text_4);

   connect(pb_1, &QPushButton::clicked, this, &QWidget::close);
}

int main(int argc, char *argv[])
{
   QApplication app(argc, argv);

   MainWindow *window = new MainWindow();
   window->show();

   return app.exec();
}